#include <errno.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/uio.h>
#include <time.h>
#include <unistd.h>    
  
#include <netinet/in.h>
#include <sys/socket.h>

#include <signal.h>

#include "drecEvent.h"

#define TAM_BUFFER 20+sizeof(struct write_info)

int file;
char buffer[TAM_BUFFER];

unsigned long *flowPtr, *seqPtr;
unsigned long *txTimePtr, *txUsecPtr; 
struct in6_addr *destPtr;

struct write_info *other_infoPtr;

void write_payload()
{
  struct tm *tx_time, *rx_time;
  unsigned long sec_aux;
  char aux[INET6_ADDRSTRLEN]; 

  /* Log packet info */ 
  /* FlowID */
  printf("Flow>%04lu ", ntohl(*flowPtr));
  
  /* Sequence number */
  printf("Seq>%06ld ", ntohl(*seqPtr)); /* seq Number */	
  
  /* Source address */
  printf("Src>%16s/%-5hd ", inet_ntoa(other_infoPtr->src_sin_addr), 
	 ntohs(other_infoPtr->src_sin_port));
  
  /* Destination address */
  printf("Dest>%16s/%-5hd ", inet_ntoa(destPtr), other_infoPtr->destPort);
  
  /* TxTime */
  *txTimePtr = ntohl(*txTimePtr);
  *txUsecPtr = ntohl(*txUsecPtr);
  tx_time = gmtime((time_t *)txTimePtr);
  printf("TxTime>%02d:%02d:%02d.%06lu ",     /* print TxTime */
	  tx_time->tm_hour, 
  	  tx_time->tm_min,
	  tx_time->tm_sec,
	  *txUsecPtr);
  
  /* RxTime */
  rx_time = gmtime((time_t *)&other_infoPtr->rxTime);
  printf("RxTime>%02d:%02d:%02d.%06lu ",     /* print RxTime */
	  rx_time->tm_hour, 
	  rx_time->tm_min,
	  rx_time->tm_sec,
	  (unsigned long) other_infoPtr->rxTime.tv_usec);
  
  /* Packet size */
  printf("Size>%04d\n", other_infoPtr->rxSize); 
}

int main(int argc, char *argv[])
{
  /* Pointers to MGEN packet payload information */
  seqPtr = (unsigned long *)(buffer);
  txTimePtr = (unsigned long *) (buffer+4);    
  txUsecPtr = (unsigned long *)(buffer + 8);
  flowPtr = (unsigned long *)(buffer + 12);
  destPtr = (struct in6_addr *)(buffer + 16);

  other_infoPtr = (struct write_info *)(buffer + 20);

  if((file = open(argv[1], O_RDONLY, 0)) < 0)
  {
    perror("Error opening file: ");
    exit(1);
  }

  while(read(file,buffer, TAM_BUFFER) > 0) 
    write_payload( buffer );  

  return 0;
}
