#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <syslog.h>
#include <sys/stat.h>
#include <math.h>          

#define MAXA  9 
#define MAXM 21


float vanz[MAXM]= {1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0,
              12.0, 14.0, 16.0, 18.0, 20.0, 22.0, 24.0, 26.0, 28.0, 30.0, 0.0};



float vert[MAXA]= {0.1,0.05,0.025,0.020,0.010,0.005,0.003,0.002,0.001};

float tvert[MAXM][MAXA]={
   { 6.314,12.706,25.452,31.821,63.657,127.3,212.2, 318.3, 636.6},
   { 2.920, 4.303, 6.205, 6.965, 9.925,14.089,18.216,22.327,31.6},
   { 2.353, 3.182, 4.177, 4.541, 5.841, 7.453, 8.891,10.214,12.922},
   { 2.132, 2.776, 3.495, 3.747, 4.604, 5.597, 6.435, 7.173, 8.610},
   { 2.015, 2.571, 3.163, 3.365, 4.032, 4.773, 5.376, 5.893, 6.869},
   { 1.943, 2.447, 2.969, 3.143, 3.707, 4.317, 4.8,   5.208, 5.959},
   { 1.895, 2.365, 2.841, 2.998, 3.499, 4.029, 4.442, 4.785, 5.408},
   { 1.860, 2.306, 2.752, 2.896, 3.355, 3.833, 4.199, 4.501, 5.041},
   { 1.833, 2.262, 2.685, 2.821, 3.250, 3.690, 4.024, 4.297, 4.781},
   { 1.812, 2.228, 2.634, 2.764, 3.169, 3.581, 3.892, 4.144, 4.587},
   { 1.782, 2.179, 2.560, 2.681, 3.055, 3.428, 3.706, 3.930, 4.318},
   { 1.761, 2.145, 2.510, 2.624, 2.977, 3.326, 3.583, 3.787, 4.140},
   { 1.746, 2.120, 2.473, 2.583, 2.921, 3.252, 3.494, 3.686, 4.015},
   { 1.734, 2.101, 2.445, 2.552, 2.878, 3.193, 3.428, 3.610, 3.922},
   { 1.725, 2.086, 2.423, 2.528, 2.845, 3.153, 3.376, 3.552, 3.849},
   { 1.717, 2.074, 2.405, 2.508, 2.819, 3.119, 3.335, 3.505, 3.792},
   { 1.711, 2.064, 2.391, 2.492, 2.797, 3.092, 3.302, 3.467, 3.745},
   { 1.706, 2.056, 2.379, 2.479, 2.779, 3.067, 3.274, 3.435, 3.704},
   { 1.701, 2.048, 2.369, 2.467, 2.763, 3.047, 3.250, 3.408, 3.674},   { 1.697, 2.042, 2.360, 2.457, 2.750, 3.030, 3.230, 3.386, 3.646},
   { 1.645, 1.960, 2.241, 2.326, 2.576, 2.807, 2.968, 3.090, 3.291},
  };



int nearby (float  x, float y, float d)
{
   float z;

        z = x-y;

        if (z < 0.0)
           z = z * (-1.0); 

        if (z <= d)         
           return (1);
        else
           return (0);
}





// Funcion a la que le pasamos un array de datos, el numero de datos del
// array, y el nivel de confianza deseado en %(ej : 90,95,97.5,98,99,99.5
// 99.7,99.8,99.9) Solo se permiten estos niveles de confianza.

// Resultados: media, varianza (Sy.Sy), y la anchura del intervalo.

// Los resultados se leen de la siguiente forma: con probabilidad cl, el 
// resultado esta comprendido entre media-dx y media+dx

// Si el nivel de confianza no es el adecuado devuelve -1


 int confInterval (float x[], int number,float cl,float *Mean, float *Var, float *Dx,int valor) {

  int i,k,j;
  float y;
  float a,mean,var,dx;
  

   mean =  x[0];
  
   var = 0.0;
   y   = 1.0;

   for ( i=1 ; i<number ; i++ )
   {
      y = y + 1.0;
      var = (y-2)/(y-1) * var + (x[i]-mean)*(x[i]-mean)/y;         
      mean = (float) (mean + (x[i]-mean)/y);
   }
    
  if ( number>150)
   {
      k=MAXM-1;
   }
   else
   {
      for ( j=0 ; j<number ; j++ )
      {
         if ( (int)vanz[j] > number-1 )
         {

            break;
         }
      }
      k=j-1;
   }


  for ( j=0; j<MAXA ;j++)
   {
       if ( nearby (cl, 100.0*(1.0-vert[j]), 0.0001) ) {
	   break; 
       }
   }

  if ( j == MAXA )
   { 
     dx = -1.0;  
     memcpy(Mean, &mean,sizeof(float));
     memcpy(Var,&var,sizeof(float));
       memcpy(Dx,&dx,sizeof(float)); 
     return (0) ;
   }
 
  dx = tvert[k][j] * sqrt(var/y);

  // Aqui tenemos que comprobar si es 
  // mayor o menor que el valor que queremos
  memcpy(Mean, &mean,sizeof(float));
  memcpy(Var,&var,sizeof(float));
  memcpy(Dx,&dx,sizeof(float)); 
 
  a=(dx/mean)*100; 
  printf("Intervalo de confianza %f \n",a);  
  if (a>valor) return (-1);  
  else return (0);


}




int escribir_valores(int rate,int delay,int jitter,int drops,int delay_max,char *direc){

  FILE *f_rate,*f_delay,*f_jitter,*f_drops,*f_val,*f_delay_max;
  int num_val;
  char name[100];


  strcpy(name,direc);
  strncat(name ,"/val_tmp",strlen("/val_tmp"));

  f_val=fopen(name,"r");
  fscanf(f_val, "%d", &num_val);
  fclose(f_val); 

  num_val=num_val+1;

  f_val=fopen(name,"w+");
  fprintf(f_val, "%d ", num_val);
  fclose(f_val); 

  strcpy(name,"");  
  strcpy(name,direc);
  strncat(name ,"/rate_tmp",strlen("/rate_tmp"));

  f_rate=fopen(name,"a+");
  fprintf(f_rate, "%d ", rate);  
  fclose(f_rate);

  strcpy(name,"");  
  strcpy(name,direc);
  strncat(name ,"/delay_tmp",strlen("/delay_tmp"));

  f_delay=fopen(name,"a+");
  fprintf(f_delay, "%d ", delay);  
  fclose(f_delay);

  strcpy(name,"");  
  strcpy(name,direc);
  strncat(name ,"/jitter_tmp",strlen("/jitter_tmp"));
 
  f_jitter=fopen(name,"a+");
  fprintf(f_jitter, "%d ", jitter);  
  fclose(f_jitter);

  strcpy(name,"");  
  strcpy(name,direc);
  strncat(name ,"/drops_tmp",strlen("/drops_tmp"));
 
  f_drops= fopen(name,"a+");
  fprintf(f_drops, "%d ", drops);  
  fclose(f_drops);
  
  strcpy(name,"");  
  strcpy(name,direc);
  strncat(name ,"/md_tmp",strlen("/md_tmp"));
 
  f_delay_max= fopen(name,"a+");
  fprintf(f_delay_max, "%d ", delay_max);  
  fclose(f_delay_max);
  
  return num_val;
}


int comprobar_intervalo(char *direc){

 float x[30];
 int cl=95;
 int valor=2;
 float mean,var,dx;
 int aux;
 int num_val,i,flow_number;
 char name[100];

 FILE *f_rate,*f_delay,*f_jitter,*f_drops,*fd_max;
 FILE *tasa,*retardo,*jit,*dr,*flujo,*f_val,*ret_max;



 strcpy(name,"");  
 strcpy(name,direc);
 strncat(name ,"/val_tmp",strlen("/val_tmp"));

 f_val=fopen(name,"r");
 fscanf(f_val, "%d", &num_val);
 fclose(f_val);
   
 strcpy(name,"");  
 strcpy(name,direc);
 strncat(name ,"/rate_tmp",strlen("/rate_tmp"));
 
 f_rate=fopen(name,"r");
 for (i=0;i<num_val;i++){
   fscanf(f_rate, "%f", &x[i]);
 }

 fclose(f_rate);

 
 aux=confInterval(x,num_val,cl,&mean,&var,&dx,valor);
 
 if (num_val>9) {
    aux=0;
    printf("Numero de pruebas mayor que 9"); 
 }
 if (aux==0){

   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/flow.txt",strlen("/flow.txt"));

   flujo=fopen(name,"r");
   fscanf(flujo, "%d", &flow_number);
   fclose(flujo);
  
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/val_tmp",strlen("/val_tmp"));

   f_val=fopen(name,"w+");
   fprintf(f_val,"%d ",0);
   fclose(f_val);

   
   // rate

   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/rate.txt",strlen("/rate.txt"));

   tasa=fopen(name,"a+"); 
   fprintf(tasa,"%d\n",(int) mean);
   if (flow_number==20)  fprintf(tasa,"\n********************** \n\n");
   fclose(tasa); 

   // delay
   
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/delay_tmp",strlen("/delay_tmp"));

   f_delay=fopen(name,"r");
  
   for (i=0;i<num_val;i++){
     fscanf(f_delay, "%f", &x[i]);
   }

   fclose(f_delay);

   aux=confInterval(x,num_val,cl,&mean,&var,&dx,valor);
   
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/delay.txt",strlen("/delay.txt")); 
 
   retardo=fopen(name,"a+"); 
   fprintf(retardo,"%d\n",(int) mean);
   if (flow_number==20)  fprintf(retardo,"\n********************** \n\n");
   fclose(retardo);  

    
   //  delay_max 
 
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/md_tmp",strlen("/md_tmp"));

   fd_max=fopen(name,"r");
  
   for (i=0;i<num_val;i++){
     fscanf(fd_max, "%f", &x[i]);
   }

   fclose(fd_max);

   aux=confInterval(x,num_val,cl,&mean,&var,&dx,valor);
  
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/maxDelay.txt",strlen("/maxDelay.txt"));
   
   ret_max=fopen(name,"a+"); 
   fprintf(ret_max,"%d\n",(int) mean);
   if (flow_number==20)  fprintf(ret_max,"\n********************** \n\n");
   fclose(ret_max);  
 
   // jitter

   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/jitter_tmp",strlen("/jitter_tmp"));

   f_jitter=fopen(name,"r");
  
   for (i=0;i<num_val;i++){
     fscanf(f_jitter, "%f", &x[i]);
   }
   
   fclose(f_jitter);
   
   aux=confInterval(x,num_val,cl,&mean,&var,&dx,valor);
  
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/jitter.txt",strlen("/jitter.txt"));

   jit=fopen(name,"a+"); 
   fprintf(jit,"%d\n",(int) mean);
   if (flow_number==20)  fprintf(jit,"\n********************** \n\n");
   fclose(jit);  

   // drops
  
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/drops_tmp",strlen("/drops_tmp"));

   f_drops=fopen(name,"r");
  
   for (i=0;i<num_val;i++){
     fscanf(f_drops, "%f", &x[i]);
   }

   fclose(f_drops);

   aux=confInterval(x,num_val,cl,&mean,&var,&dx,valor);
   
   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/drop.txt",strlen("/drop.txt"));
 
  
   dr=fopen(name,"a+");   
   fprintf(dr,"%d\n",(int) mean);  
   if (flow_number==20)  fprintf(dr,"\n********************** \n\n");
   fclose(dr);  
 
   if (flow_number==20) flow_number=0;

   flow_number=flow_number+1;

   strcpy(name,"");  
   strcpy(name,direc);
   strncat(name ,"/flow.txt",strlen("/flow.txt"));

   flujo=fopen(name,"w+");
   fprintf(flujo, "%d ",flow_number);
   fclose(flujo); 

   return (0);
   
 }
  else  return (1);
 
 

 }
